unit FontDialogUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  TntClasses, TntStdCtrls, TntForms;

type
  TFontSelDialog = class(TTntForm)
    Panel1: TTntScrollBox;
    TntLabel1: TTntLabel;
    ListBox_FontSize: TTntListBox;
    Label12: TTntLabel;
    ListBox_FontName: TTntListBox;
    Label11: TTntLabel;
    Button_OK: TTntButton;
    Button_Cancel: TTntButton;
    CheckBox_Forreign1: TTntCheckBox;
    CheckBox_Variable1: TTntCheckBox;
    TntLabel2: TTntLabel;
    procedure FormShow(Sender: TObject);
    procedure CheckBox_Variable1Click(Sender: TObject);
    procedure CheckBox_Forreign1Click(Sender: TObject);
    procedure ListBox_FontSizeClick(Sender: TObject);
    procedure ListBox_FontNameClick(Sender: TObject);
    procedure ListBox_FontNameDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure BuildFontList;
    function GetOptions: TFont;
    procedure SetOptions(const Value: TFont);
  public
    { Public 錾 }
    property Options: TFont read GetOptions write SetOptions;
  end;

implementation

{$R *.dfm}

uses Math, FontUtils;

const
  Min_FontSize = 8;
  Max_FontSize = 40;

var
  FShowForeign: boolean;
  FShowVariable: boolean;

// tHg̎擾
function EnumFontFamProc(var EnumLogFont: TEnumLogFontW;
  var NewTextMetric: TNewTextMetricW; FontType: Integer;
  Data: Pointer): Integer; stdcall;
var
  Items: TtntStrings;
  TM: TEXTMETRICW;
begin
  Items := TFontSelDialog(Data).ListBox_FontName.Items;
  Result := 1;
  // @
  if EnumLogFont.elfLogFont.lfFaceName[0] = '@' then Exit;
  // TMPF_FIXED_PITCH = 1 is variable pitch font
  if (not FShowVariable) then begin
    if (NewTextMetric.tmPitchAndFamily and 1) = 1 then Exit;
    //ۂTMȂƌꂿႤ
    with TFontSelDialog(Data).TntLabel2.Canvas do begin
      Font.Name := EnumLogFont.elfLogFont.lfFaceName;
      Font.Charset := GetFontCharSet(EnumLogFont.elfLogFont.lfFaceName);
      GetTextMetricsW(Handle, TM);
    end;
    if ((TM.tmPitchAndFamily and 1) = 1) then Exit;
  end;
  //if WideString(EnumLogFont.elfLogFont.lfFaceName) <> '' then
  //if NewTextMetric.tmCharSet <> SHIFTJIS_CHARSET then exit;
  //if NewTextMetric.tmCharSet <> DEFAULT_CHARSET then exit;
  //if NewTextMetric.tmCharSet <> ANSI_CHARSET then exit;
  if NewTextMetric.tmCharSet = SYMBOL_CHARSET then exit;
  if (not FShowForeign) and (NewTextMetric.tmCharSet <> SHIFTJIS_CHARSET) then exit;
  Items.Add(EnumLogFont.elfLogFont.lfFaceName);
end;

procedure TFontSelDialog.BuildFontList;
var
  DC: HDC;
  i: integer;
begin
  ListBox_FontName.Items.Clear;
  DC:= GetDC(0);
  EnumFontFamiliesW(DC, nil, @EnumFontFamProc, Longint(Pointer(Self)));
  ReleaseDC(0, DC);
  ListBox_FontName.Sorted := true;
  i := ListBox_FontName.Items.IndexOf(TntLabel1.Font.Name);
  if i >= 0 then ListBox_FontName.Items.Delete(i);
  ListBox_FontName.Items.Insert(0, TntLabel1.Font.Name);
end;

procedure TFontSelDialog.FormCreate(Sender: TObject);
var
  i: integer;
begin
  for i := Min_FontSize to Max_FontSize do
    ListBox_FontSize.Items.Add(FloatToStr(Round(i * 0.75 * 2) * 0.5));
  TntLabel1.Caption :=
    'abcdefghijklmnopqrstuvwxyz' + #13#10 +
    'ABCDEFGHIJKLMNOPQRSTUVWXYZ' + #13#10 +
    '͂ɂقւƂʂ' + #13#10 +
    'Cnjzwg`k' + #13#10 +
    '0123456789@ABCDEFG' + #13#10 +
    '٦ܶڿ';
  CheckBox_Forreign1.Checked := FShowForeign;
  CheckBox_Variable1.Checked := FShowVariable;
end;

procedure TFontSelDialog.ListBox_FontNameDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ws:widestring;
  TM: TEXTMETRICW;

begin
  with TntLabel2.Canvas do
  begin
    ws:=ListBox_FontName.Items[Index];
    Font.Name := ws;
    Font.Charset := GetFontCharSet(ws);
  end;
  with (Control as TtntListBox).Canvas do
  begin
    if not (odSelected in State) then begin
      GetTextMetricsW(TntLabel2.Canvas.Handle, TM);
      if (TM.tmPitchAndFamily and 1) <> 1 then begin
        Brush.Color := clWindow;
        Font.Color := clWindowText;
      end else begin
        Brush.Color := clBtnFace;
        Font.Color := clBtnShadow;
      end;
    end;
    FillRect(Rect);
    ExtTextOutW(Handle, Rect.Left + 25, Rect.Top, ETO_CLIPPED, @Rect, PWChar(ws), Length(ws), nil);
    Font.Name := ws;
    Font.Height := -12;//BDF UM+΍
    Font.Charset := GetFontCharSet(ws);
    case Font.Charset of
      SHIFTJIS_CHARSET:begin
        //TextOutW(Handle, Rect.Left, Rect.Top, '', 1);
        ExtTextOutW(Handle, Rect.Left, Rect.Top, ETO_CLIPPED, @Rect, '', 1, nil);
        //DrawTextW(Handle, '', 1, Rect, 0);
      end;
      else begin
        //TextOutW(Handle, Rect.Left, Rect.Top, 'Aa', 2);
        ExtTextOutW(Handle, Rect.Left, Rect.Top, ETO_CLIPPED, @Rect, 'Aa', 2, nil);
        //DrawTextW(Handle, 'Aa', 2, Rect, 0);
      end;
    end;
  end;
end;

procedure TFontSelDialog.ListBox_FontNameClick(Sender: TObject);
var
  ws: WideString;
begin
  ws := ListBox_FontName.Items[ListBox_FontName.ItemIndex];
  with TntLabel1 do begin
    Font.Name := ws;
    Font.Charset := GetFontCharSet(ws);
    Invalidate;
  end;
end;

procedure TFontSelDialog.ListBox_FontSizeClick(Sender: TObject);
begin
  with TntLabel1 do begin
    Font.Height := -(ListBox_FontSize.ItemIndex + Min_FontSize);
    Invalidate;
  end;
end;

function TFontSelDialog.GetOptions: TFont;
begin
  Result := TntLabel1.Font;
end;

procedure TFontSelDialog.SetOptions(const Value: TFont);
begin
  with TntLabel1.Font do begin
    Name := Value.Name;
    Charset := GetFontCharSet(Value.Name);
    Height := -Min(Max(Abs(Value.Height), Min_FontSize), Max_FontSize);
    Invalidate;
  end;
  BuildFontList;
  ListBox_FontName.ItemIndex := ListBox_FontName.Items.IndexOf(Value.Name);
  ListBox_FontSize.ItemIndex := abs(Value.Height) - Min_FontSize;
end;

procedure TFontSelDialog.CheckBox_Forreign1Click(Sender: TObject);
begin
  FShowForeign := CheckBox_Forreign1.Checked;
  BuildFontList;
  ListBox_FontName.ItemIndex := ListBox_FontName.Items.IndexOf(TntLabel1.Font.Name);
end;

procedure TFontSelDialog.CheckBox_Variable1Click(Sender: TObject);
begin
  FShowVariable := CheckBox_Variable1.Checked;
  BuildFontList;
  ListBox_FontName.ItemIndex := ListBox_FontName.Items.IndexOf(TntLabel1.Font.Name);
end;

procedure TFontSelDialog.FormShow(Sender: TObject);
begin
  BuildFontList;
  ListBox_FontName.ItemIndex := ListBox_FontName.Items.IndexOf(TntLabel1.Font.Name);
  ListBox_FontSize.ItemIndex := abs(TntLabel1.Font.Height) - Min_FontSize;
end;

end.
