unit StringsPrinterProgress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, TntForms, TntStdCtrls, TntComCtrls;

type
  TFormStringsPrinterProgress = class(TTntForm)
    Label1: TTntLabel;
    Button1: TTntButton;
    ProgressBar1: TTntProgressBar;
    procedure Button1Click(Sender: TObject);
  public
    CanNotProgress: Boolean;
    procedure Progress(const S: WideString; Range, Position: Integer);
    class function Execute(AOwner: TComponent; const S: WideString): TFormStringsPrinterProgress;
  end;

implementation

{$R *.DFM}

class function TFormStringsPrinterProgress.Execute(AOwner: TComponent;
  const S: WideString): TFormStringsPrinterProgress;
begin
  Result := TFormStringsPrinterProgress.Create(AOwner);
  Result.Caption := TntApplication.Title;
  Result.Label1.Caption := S;
  Result.ProgressBar1.Position := 0;
  Result.Show;
end;

procedure TFormStringsPrinterProgress.Progress(const S: WideString; Range, Position: Integer);
begin
  Label1.Caption := S;
  Label1.Update;
  if Range = 0 then
  begin
    Position := 1;
    Range := 1;
  end;
  ProgressBar1.Position := Round(Position / Range * 100);
  ProgressBar1.Update;
  Application.ProcessMessages;
end;

procedure TFormStringsPrinterProgress.Button1Click(Sender: TObject);
begin
  CanNotProgress := True;
end;

end.
