//OLE Drag & Drop ꂽ TEditor gR|[lg
//http://homepage3.nifty.com/~katsuhiko/
//TEditor̃hbOhbvR|ɕthOledd.pas̃NX𗘗p
//jR[hɍւĂ

unit DragDropClasses;

interface

uses Windows, ActiveX, hOledd;

const
  FormatEtcTEXT: TFormatEtc = (
     cfFormat: CF_TEXT;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );
  FormatEtcHDROP: TFormatEtc = (
     cfFormat: CF_HDROP;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );
  FormatEtcUniTEXT: TFormatEtc = (
     cfFormat: CF_UNICODETEXT;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );

type
  TDDString = class(TDataObject, IDataObject)
  private
    FData: WideString;
  protected
    function GetMedium(const FormatEtc: TFormatEtc; var Medium: TStgMedium;
      CreateMedium: Boolean): HResult; override;
  public
    constructor Create;
    property Text: WideString read FData write FData;
  end;

  TDDSource = class (TInterfacedObject, IDropSource)
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  end;

implementation

uses SysUtils;

{ TDDString }

constructor TDDString.Create;
begin
  inherited Create;
  FormatList.Add(FormatEtcTEXT);
  FormatList.Add(FormatEtcUniTEXT);
end;

function TDDString.GetMedium(const FormatEtc: TFormatEtc;
  var Medium: TStgMedium; CreateMedium: Boolean): HResult;
var
  hMem: HGLOBAL;
  Buffer: Pointer;
  len: integer;
  i:integer;
begin

  if not CreateMedium then
  begin
    Result := E_NOTIMPL;
    Exit;
  end;
  if FormatEtc.cfFormat = CF_UNICODETEXT then begin
    len := Length(FData);
    hMem := GlobalAlloc(GHND, len * 2 + 2);
    if hMem <> 0 then begin
      Buffer := GlobalLock(hMem);
      for i := 0 to len - 1 do (PWChar(Buffer) + i)^ := (PWChar(FData) + i)^;
      GlobalUnlock(hMem);
      Medium.hGlobal := hMem;
      Medium.tymed   := FormatEtc.tymed;
      Result := S_OK;
    end else Result := STG_E_MEDIUMFULL;
  end else begin
    hMem := GlobalAlloc(GHND, Length(AnsiString(FData)) + 1);
    if hMem <> 0 then begin
      Buffer := GlobalLock(hMem);
      StrCopy(PAnsiChar(Buffer), PAnsiChar(AnsiString(Fdata)));
      GlobalUnlock(hMem);
      Medium.hGlobal := hMem;
      Medium.tymed   := FormatEtc.tymed;
      Result := S_OK;
    end else Result := STG_E_MEDIUMFULL;
  end;
end;

{ TDDSource }

function TDDSource.GiveFeedback(dwEffect: Integer): HResult;
begin
  Result := DRAGDROP_S_USEDEFAULTCURSORS;
end;

function TDDSource.QueryContinueDrag(fEscapePressed: BOOL;
  grfKeyState: Integer): HResult;
begin
  if fEscapePressed or (grfKeyState and MK_RBUTTON = MK_RBUTTON) then
    // GXP[vL[ꂽA}EX̉E{^ꂽ
    Result := DRAGDROP_S_CANCEL
  else
    if grfKeyState and MK_LBUTTON = 0 then
      // }EX̍{^Ă
      Result := DRAGDROP_S_DROP
    else
      Result := S_OK;
end;

end.
