unit NotePadSearch;

interface

uses Windows, Math, StringBuffer;


//BM@炵Ă݂悤
//http://www.i.kyushu-u.ac.jp/~takeda/PM/BM/bm.html
//http://www2.starcat.ne.jp/~fussy/algo/algo7-4.htm
//Jn̑OɃe[ủKvȂ̂ŁA
//̂тɂƂAvfύX̂тɂȂA
//vfύXꂽtO𗧂ĂāA
//JnOɃtO`FbNĉB

type
  TSearchBM = class
  private
    FPattern: WideString;
    FPatternLength: integer;
    FSubStr: WideString;
    FSaveString: WideString;
    FTableDown,FTableUp: packed array [$0000 .. $FFFF] of integer;
    FIgCase: boolean;
    FNeedInit: boolean;
    function DeltaDown(AChar: PWideChar; ACount: integer): integer;
    function DeltaUp(AChar: PWideChar; ACount: integer): integer;
    procedure InitTable;
    procedure SetPattern(const Value: WideString);
    procedure SetIgCase(const Value: boolean);
  public
    constructor Create;
    destructor Destroy; override;
    function Search(MainStr: PWideChar; MainLen, StartPos, EndPos: integer; ADown: boolean): integer;
    property SubStr: WideString read FSubStr write SetPattern;
    property IgCase: boolean read FIgCase write SetIgCase;
  end;

var
  SearchBM: TSearchBM;

procedure UnitInitialize;

implementation

(* Eӂ̌
const
// FindWideStr̊{ Flags
  FWS_UP         =0;
  FWS_DOWN       =1;
  FWS_IGNORECASE =2;
  FWS_IGNOREWIDE =4;
// FindWideStr̕Flags
  FWS_DOWN_IGNORECASE     =3;// FWS_DOWN + FWS_IGNORECASE
  FWS_DOWN_IGNOREWIDE     =5;// FWS_DOWN + FWS_IGNOREWIDE
  FWS_DOWN_IGNORECASEWIDE =7;// FWS_DOWN + FWS_IGNORECASEWIDE
  FWS_UP_IGNORECASE  =FWS_IGNORECASE;
  FWS_UP_IGNOREWIDE  =FWS_IGNOREWIDE;
  FWS_UP_IGNORECASEWIDE   =6;// FWS_IGNORECASE + FWS_IGNOREWIDE

  FWS_IGNORECASEWIDE = FWS_UP_IGNORECASEWIDE;

function AisB(A, B: PWideChar; Count: Cardinal): boolean;
// G[̃`FbNȂ̂Œ
var
  i: integer;
begin
  Result := false;
  for i := 0 to Count - 1 do
  begin
    if (A + i)^ <> (B + i)^ then Exit;
  end;
  Result:=true;
end;

function igCase(W: PWideChar): WideChar;
begin
  Result := W^;
  CharUpperBuffW(@Result, 1);
end;

function igCases(W: PWideChar; Count: Cardinal): WideString;
begin
  Result := W;
  SetLength(Result, Count);
  CharUpperBuffW(PWChar(Result), Count);
end;

function AisBigCase(igA, B: PWideChar; Count: Cardinal): boolean;
// G[̃`FbNȂ̂Œ
var
  i: integer;
begin
  Result := false;
  for i := 0 to Count-1 do
  begin
    if igcase(igA + i) <> (B + i)^ then Exit;
  end;
  Result := true;
end;

function FindWideStr(MainStr, SubStr: PWideChar;
  MainLen, SubLen, StartPos, EndPos: integer; Flags: byte):Cardinal;
//1ڂqbgꍇ1ԂFs0
//Lbg0Downꍇ(1ڂƔr)StartPos0邱
//Lbg1Upɂ(1ڂƔr)StartPos1邱
//Ō܂DownȂEndPos=MainLenAŌ܂UpȂEndPos=1邱
////G[̃`FbNȂ̂Œ
var
  i: integer;
  ws: Widestring;
begin
  Result := 0;
  if (MainLen < 1) or (SubLen < 1) then exit;
  case Flags of
  FWS_DOWN:
  begin
    inc(MainStr, StartPos);
    for i := StartPos + 1 to Min(MainLen, EndPos) - (SubLen - 1) do begin
      if AisB(MainStr, SubStr, SubLen) then begin
        Result := i;
        exit;
      end;
      inc(MainStr);
    end;
  end;
  FWS_DOWN_IGNORECASE:
  begin
    inc(MainStr, StartPos);
    ws := igCases(SubStr, Sublen);
    for i := StartPos + 1 to Min(MainLen, EndPos) - (SubLen - 1) do begin
      if AisBigCase(MainStr, PWideChar(ws), SubLen) then begin
        Result := i;
        exit;
      end;
      inc(MainStr);
    end;
  end;
  FWS_UP:
  begin
    inc(MainStr, StartPos - 1);
    for i := StartPos downto Max(1, EndPos) do begin
      if AisB(MainStr, SubStr, SubLen) then begin
        Result := i;
        exit;
      end;
      Dec(MainStr);
    end;
  end;
  FWS_UP_IGNORECASE:
  begin
    inc(MainStr, StartPos - 1);
    ws := igCases(SubStr, Sublen);
    for i := StartPos downto Max(1, EndPos) do begin
      if AisBigCase(MainStr, PWideChar(ws), SubLen) then begin
        Result := i;
        exit;
      end;
      Dec(MainStr);
    end;
  end;
  end;//case
end;
*)


{ TSearchBM }

constructor TSearchBM.Create;
begin
  inherited;
  FNeedInit := false;
  FIgCase := true;
  FSubStr := '';
  FPattern := '';
  FPatternLength := 0;
  //FBMString := TStringBuffer.Create(FPatternLength);
  FSaveString := '';
end;

function TSearchBM.DeltaDown(AChar: PWideChar; ACount: integer): integer;
begin
  //Result := FTableDown[Word(AChar^)];
  //if Result = 0 then Result := FPatternLength + 1 - ACount else
  //Result := Max(Result - ACount, 1);
  //obNXChꍇ2i߂邱Ƃo
  Result := FTableDown[Word(AChar^)] + FPatternLength + 1 - ACount;
  if Result < 1 then Result := 2;
end;

function TSearchBM.DeltaUp(AChar: PWideChar; ACount: integer): integer;
begin
  //Result := FTableUp[Word(AChar^)];
  //if Result = 0 then Result := FPatternLength + 1 - ACount else
  //Result := Max(Result - ACount, 1);
  Result := FTableUp[Word(AChar^)] + FPatternLength + 1 - ACount;
  if Result < 1 then Result := 2;
end;

destructor TSearchBM.Destroy;
begin
  //FBMString.Free;
  inherited;
end;

procedure TSearchBM.InitTable;
var
  i{, j}: integer;
  //ANoHit: boolean;
begin
  FNeedInit := false;
  //Ogpe[uAOgpQɏ
  //Ƀ_uȂ悤`FbN邽߂FBMStringQ́A
  //ɂ͎gȂAe[u̍̂߂ɕێĂB
  //for i := 0 to FBMString.StringLength -1 do begin
  //  FTableDown[integer(FBMString.Chars[i])] := 0;
  //  FTableUp[integer(FBMString.Chars[i])] := 0;
  //end;
  for i := 1 to Length(FSaveString) do begin
    FTableDown[integer(FSaveString[i])] := 0;
    FTableUp[integer(FSaveString[i])] := 0;
  end;
  //Ɖł͎up^[̏Ԃς̂ŕʌɑ{
  {FBMString.Remove(0, FBMString.StringLength);
  for i := FPatternLength downto 1 do begin
    ANoHit := true;
    for j := 0 to FBMString.StringLength - 1 do begin
      if FPattern[i] = FBMString.Chars[j] then begin
        ANoHit := false;
        break;
      end;
    end;
    if ANoHit then begin
      FBMString.Append(FPattern[i]);
      //FTableDown[integer(FPattern[i])] := FPatternLength - i + 1;
      FTableDown[integer(FPattern[i])] := - i;
    end;
  end;
  FBMString.Remove(0, FBMString.StringLength);
  for i := 1 to FPatternLength do begin
    ANoHit := true;
    for j := 0 to FBMString.StringLength - 1 do begin
      if FPattern[i] = FBMString.Chars[j] then begin
        ANoHit := false;
        break;
      end;
    end;
    if ANoHit then begin
      FBMString.Append(FPattern[i]);
      //FTableUp[integer(FPattern[i])] := i;
      FTableUp[integer(FPattern[i])] := i - FPatternLength - 1;
    end;
  end;  }
  FSaveString := FPattern;
  for i := 1 to FPatternLength do begin
    FTableDown[integer(FPattern[i])] := - i;
  end;
  //for i := FPatternLength downto 1 do begin
  //  FTableUp[integer(FPattern[i])] := i - FPatternLength - 1;
  //end;
  for i := 1 to FPatternLength do begin
    FTableUp[integer(FPattern[FPatternLength + 1 - i])] := - i;
  end;
end;

function TSearchBM.Search(MainStr: PWideChar; MainLen, StartPos, EndPos: integer;
  ADown: boolean): integer;
var
  i, j, Skip: integer;
  C: WideChar;
begin
  Result := 0;
  if (MainLen < 1) or (FPatternLength < 1) then exit;
  if FNeedInit then InitTable;
  skip := 0;
  if ADown then begin
    inc(MainStr, StartPos);
    EndPos := Min(MainLen, EndPos);
    if FIgCase then begin
      i := StartPos + 1;
      while i <= EndPos - (FPatternLength - 1) do begin
        j := FPatternLength - 1;
        while j > -1 do begin
          C := (MainStr + j)^;
          CharUpperBuffW(@C, 1);
          if C <> FPattern[j + 1] then begin
            skip := DeltaDown(@C, FPatternLength - j);
            break;
          end;
          dec(j);
        end;
        if j = -1 then begin
          Result := i;
          exit;
        end;
        inc(MainStr, skip);
        inc(i, skip);
      end;
    end else begin
      i := StartPos + 1;
      while i <= EndPos - (FPatternLength - 1) do begin
        j := FPatternLength - 1;
        while j > -1 do begin
          C := (MainStr + j)^;
          if C <> FPattern[j + 1] then begin
            skip := DeltaDown(@C, FPatternLength - j);
            break;
          end;
          dec(j);
        end;
        if j = -1 then begin
          Result := i;
          exit;
        end;
        inc(MainStr, skip);
        inc(i, skip);
      end;
    end;
  end else begin
    inc(MainStr, StartPos - 1);
    EndPos := Max(1, EndPos);
    if FIgCase then begin
      i := StartPos;
      while i >= EndPos do begin
        j := 0;
        while j < FPatternLength do begin
          C := (MainStr + j)^;
          CharUpperBuffW(@C, 1);
          if C <> FPattern[j + 1] then begin
            skip := DeltaUp(@C, j +1);
            break;
          end;
          inc(j);
        end;
        if j = FPatternLength then begin
          Result := i;
          exit;
        end;
        Dec(MainStr, skip);
        dec(i, skip);
      end;
    end else begin
      i := StartPos;
      while i >= EndPos do begin
        j := 0;
        while j < FPatternLength do begin
          C := (MainStr + j)^;
          if C <> FPattern[j + 1] then begin
            skip := DeltaUp(@C, j +1);
            break;
          end;
          inc(j);
        end;
        if j = FPatternLength then begin
          Result := i;
          exit;
        end;
        Dec(MainStr, skip);
        dec(i, skip);
      end;
    end;
  end;
end;

procedure TSearchBM.SetIgCase(const Value: boolean);
begin
  if FIgCase = Value then exit;
  FIgCase := Value;
  FPattern := SubStr;
  if FIgCase then CharUpperBuffW(PWChar(FPattern), FPatternLength);
  FNeedInit := true;
end;

procedure TSearchBM.SetPattern(const Value: WideString);
begin
  if FSubStr = Value then exit;
  FSubStr := Value;
  FPatternLength := Length(Value);
  FPattern := SubStr;
  if FIgCase then CharUpperBuffW(PWChar(FPattern), FPatternLength);
  FNeedInit := true;
end;

procedure UnitInitialize;
begin
  SearchBM := TSearchBM.Create;
end;

initialization
finalization
  if Assigned(SearchBM) then SearchBM.Free;
end.
