unit HeapChecker;
(***********************************************************

	HeapChecker

	NXCX^XAGetMemŊmۂq[v̊JYo郆jbgB


	g
		vWFNg\[X(*.dpr)̐擪

			uses HeapChecker;

		ƋLqBHeapCheckeȓOɕʂ̃jbgw肵Ă͂ȂB
		vWFNg\[X̐擪
		begin
			HeapChecker.OutputClassName := True;
			HeapChecker.DumpLeakMemory := True;
			...
		end;
		̓sǉƃ[Ñ_v
		ꂪNXł΃NX\B

	Tv
		program HeapCheckerSample;

		uses
			HeapChecker,
			Forms,
			Unit1 in 'Unit1.pas' {Form1};

		{$R *.res}

		begin
			HeapChecker.OutputClassName := True;
			HeapChecker.DumpLeakMemory := True;

			Application.Initialize;
			Application.CreateForm(TForm1, Form1);
			Application.Run;
		end.

	ӎ
		Delphi6Ńpb`KpɎs5̊JYꂪo邪A
		VCL̃oOB

***********************************************************)
interface

// gpq[v}l[W
//{$define UseOriginalMemoryManager ͓삵Ȃ}
{$define UseWin32MemoryManager}

//{$DEFINE Release}
{$DEFINE DEBUG}
{$EXTENDEDSYNTAX ON} 
{$HINTS ON}
{$IOCHECKS ON}
{$OPENSTRINGS ON}
{$REALCOMPATIBILITY OFF}
{$TYPEDADDRESS ON}
{$VARSTRINGCHECKS ON}
{$WARNINGS ON}
{$STACKFRAMES OFF}
{$WRITEABLECONST OFF}

// ˑ̌xOFFɂ
{$WARN UNIT_PLATFORM OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN SYMBOL_DEPRECATED OFF}

{$ifdef Release}
	// [Xrhp̐ݒ
	{$DEBUGINFO OFF} // OFFɂƃR[h⊮@\gȂȂB
	{$LOCALSYMBOLS ON}
	{$REFERENCEINFO ON}
	{$OPTIMIZATION ON}
	{$OVERFLOWCHECKS OFF}
	{$RANGECHECKS OFF}
{$else}
	// fobOrhp̐ݒ
	{$DEBUGINFO ON}
	{$OPTIMIZATION OFF}
	{$OVERFLOWCHECKS ON}
	{$RANGECHECKS ON}
{$endif}

var
	/// [Ñ`FbN𖳌ɂtO
	DisabledChecking: Boolean;

	/// [NĂ郁̈̃_vo͂B
	DumpLeakMemory: Boolean;

	/// [NĂ̈NXCX^XƂ݂ȂāA̖O\B
	/// 댯!!AccessViolationB̏ꍇOFFɂB
	OutputClassName: Boolean;
  AllocMemCountStart: boolean = false;

type
	TErrorReporter = object
	public
		constructor init;
		destructor done; virtual;
		function open: Boolean; virtual;
		procedure close; virtual;
		procedure output(s: string); virtual;
	end;

	TLogFileErrorReporter = object(TErrorReporter)
	private
		FHandle: THandle;
	public
		function open: Boolean; virtual;
		procedure close; virtual;
		procedure output(s: string); virtual;
	end;

// o͂JX^}CYΏς݃JX^IuWFNg̃|C^ݒ肷B
var
	ErrorReporter: ^TErrorReporter;
	LogFileReporter: TLogFileErrorReporter;

implementation

// System, WindowsjbgȊOgĂ͂Ȃ
// OSysUtilsɈˑ̂Ŏgp֎~
uses
	Windows, SysUtils;

// [eBeB֐BString̓q[vĝŃG[|[ĝݎgp邱ƁB

function IntToStr(n: Integer): String;
begin
	Str(n, Result);
end;

procedure ShowMessage(msg: String);
begin
	MessageBox(0, PChar(msg), PChar(ParamStr(0)), MB_OK or MB_ICONERROR);
end;

function Min(a, b: Integer): Integer;
begin
	if a > b then Result := b else Result := a;
end;

{$ifdef UseOriginalMemoryManager}
// AllocMemCountg`FbN

procedure Initialize;
begin
	if AllocMemCount <> 0 then
	begin
		ShowMessage(
			'NtHeapChecker̎gԈĂ܂B'+sLineBreak+
			'vWFNg\[X(.dpr)̐擪usesĉB');
		DisabledChecking := True;
		Halt(1);
	end;
end;

procedure Finalize;
begin
	if DisabledChecking then
		Exit;

	if AllocMemCount <> 0 then
		ShowMessage(IntToStr(AllocMemCount) + '̃q[v̈悪JłB');
end;
{$endif UseOriginalMemoryManager}

{$ifdef UseWin32MemoryManager}
// GlobalAlloc/Free/Reallocg`FbN
// ɃNXg̏ă[N̈_vo悤ɂB

// q[v̐擪ɕtǉwb_
type
	PHeapHeader = ^THeapHeader;
	PPHeapHeader = ^PHeapHeader;
	THeapHeader = record
		Prev: PHeapHeader;
		Next: PHeapHeader;
		Size: DWord;
		Boundary: PHeapHeader;
    Started : boolean;
	end;

function HtoP(p: Pointer): Pointer;
begin
	Result := Pointer(DWord(p) + SizeOf(THeapHeader));
end;

function PtoH(p: Pointer): PHeapHeader;
begin
	Result := PHeapHeader(DWord(p) - SizeOf(THeapHeader));
end;

function PtoHSize(Size: Integer): Integer;
begin
	Result := Size + SizeOf(THeapHeader) + SizeOf(PHeapHeader);
end;

function HtoT(p: PHeapHeader): PPHeapHeader;
begin
	Result := PPHeapHeader(Integer(p) + integer(p^.Size) + SizeOf(THeapHeader));
end;

var
	AllocMemCount: Integer;
	oldmm: TMemoryManager;
	Top: THeapHeader;
	DefaultErrorReporter: TErrorReporter;

function GetMem(Size : Integer) : Pointer;
var
	hh: PHeapHeader;
begin
	hh := PHeapHeader(GlobalAlloc(GMEM_FIXED, PToHSize(Size)));
	if (hh <> nil) then
	begin
		hh.Next := @Top;
		hh.Prev := Top.Prev;
		hh.Next.Prev := hh;
		hh.Prev.Next := hh;

		hh.Size := Size;
		hh.Boundary := hh;
    hh.Started := AllocMemCountStart;

		Result := HtoP(hh);
		HtoT(hh)^ := hh;

		Inc(AllocMemCount);
	end
	else
		Result := nil;
end;

function CheckHeap(P: Pointer): Boolean;
var
	hh: PHeapHeader;
begin
	hh := PtoH(p);
	
	Result := True;
	if hh.Boundary = hh then
		Exit;
	
	if HtoT(hh)^ = hh then
		Exit;

	Result := False;
	DebugBreak;
end;

function FreeMem(P : Pointer) : Integer;
var
	hh: PHeapHeader;
begin
	CheckHeap(P)
	;
	hh := PtoH(P);
	hh^.Prev^.Next := hh^.Next;
	hh^.Next^.Prev := hh^.Prev;

	Result:=GlobalFree(HGLOBAL(hh));
	if Result = 0 then
		Dec(AllocMemCount);
end;

function ReallocMem(P : Pointer; Size : Integer) : Pointer;
var
	hh: PHeapHeader;
begin
	// P̓[U[x̃AhXœn
	CheckHeap(P);
	hh := PtoH(P);
	Result:=Pointer(GlobalRealloc(HGLOBAL(hh), PtoHSize(Size), 0));
	if Result = nil then
	begin // gɎsnilԂ炵Bɂ悭sB
		Result := GetMem(Size);
		Move(P^, Result^, Min(PtoH(P).Size, Size));
		if FreeMem(P) <> 0 then
			; // ignore todo:|[gׂ
	end
	else
	begin
		PHeapHeader(Result).Size := Size; // TCYB
		HtoT(Result)^ := Result; // tb^̕tւ
		Result := HtoP(Result);
	end;
end;

procedure Initialize;
var
	newmm: TMemoryManager;
begin
	GetMemoryManager(oldmm);
	if AllocMemCount <> 0 then
	begin
		ShowMessage(
			'HeapChecker̎gԈĂ܂B'+sLineBreak+
			'vWFNg\[X(.dpr)̐擪usesĉB');
		DisabledChecking := True;
		Halt(1);
	end;

	newmm.GetMem := GetMem;
	newmm.FreeMem := FreeMem;
	newmm.ReallocMem := ReallocMem;
	SetMemoryManager(newmm);

	Top.Next := @Top;
	Top.Prev := @Top;

	DefaultErrorReporter.init;
	LogFileReporter.init;
	ErrorReporter := @LogFileReporter; //@DefaultErrorReporter;<-x
end;

procedure Finalize;
	procedure output(s: string);
	begin
		ErrorReporter^.output(s);
	end;

  function getStarted(b: boolean): String;
  begin
    if b then Result := 'Started' else Result := '';
  end;

	procedure MemoryDump(addr: Pointer; size: Integer; Caption: String; Started: boolean);
	const
		h = '0123456789ABCDEF ';

		procedure Hex(buf: PChar; n: DWORD; width: Integer = 8);
		var
			i: Integer;
			p: PChar;
		begin
			for i := 0 to width - 1 do
			begin
				p := buf + width-1-i;
				p^ := h[n and $f+1];
				n := n div $10;
			end;
		end;

	var
		p, q: ^Byte;
		s, t: String;
		i: Integer;
		c: PChar;
	begin
		s := '12345678 |                        -                        | ????????????????';
		t := '-----------------------------------------------------------------------------';

		p := addr;
		q := addr; Inc(q, size);
		// o
		output(t);
		output(' ADDRESS | ' + Caption+ '(size:'+ IntToStr(size) + ')' + getStarted(Started));
		output(t);
		while DWord(p) < DWord(q) do
		begin
			hex(@s[1], DWORD(p));
			for i := 0 to 15 do
			begin
				c := @s[62+i];
				if DWord(p)<DWord(q) then
				begin
//					if p^ in [$20..$7f-1] then
					if not(p^ in [$00..$19]) then
						c^ := Char(p^);
					hex(@s[12+i*3], p^, 2);
				end else
					c^ := ' ';

				Inc(p);
			end;
			output(s);
		end;
		output(t);
	end;
var
	p: PHeapHeader;
	i: Integer;
	vmt: DWord;
	s: String;
begin
	if DisabledChecking then
		Exit;

	SetMemoryManager(oldmm);

	if AllocMemCount <> 0 then
	begin
		if (Windows.MessageBox(0, PChar(IntToStr(AllocMemCount) + '̃q[v̈悪JłB'+sLineBreak+'ڍׂo͂܂H'),
			'HeapChecker', MB_YESNO) = IDYES) then
		begin
			if ErrorReporter^.open then
			begin
				p := Top.Next;
				i := 1;
				while p <> @Top do
				begin
					s := '';
					try
						if OutputClassName then
						begin
							// NX\Ă݂
							vmt := DWORD(HToP(p)^);
							if ($00400000 <= vmt) and (vmt <= $00500000) then // Ȃ肢Ȕ
              //if VMT <> 0 then
								s := '(NX:'+TObject(HtoP(p)).ClassName+')'
              else s := '(VMT'+IntToHex(vmt,8)+')';
						end;
					except
						// ignore exception
					end;

					if DumpLeakMemory then
					begin
						MemoryDump(HtoP(p), p^.Size, '̈'+IntToStr(i) + s, p^.Started);
			//			MemoryDUmp(PtoH, PtoHSize(p^.Size), '̈'+IntToStr(i)+'(wb_)');
					end;
					Inc(i);
					p := p.Next;
				end;

				ErrorReporter^.close;
			end
			else
				ShowMessage('|[gIuWFNg̏Ɏs܂');
		end;
//		ShowMessage(IntToStr(AllocMemCount) + '̃q[v̈悪JłB');
	end;
	DefaultErrorReporter.done;
  LogFileReporter.done;
end;
{$endif}

{ TErrorReporter }

function TErrorReporter.open: Boolean;
begin
	Result := True;
end;

procedure TErrorReporter.close;
begin
	// do nothing
end;

procedure TErrorReporter.output(s: string);
begin
	Windows.OutputDebugString(PChar(s+sLineBreak));
end;

destructor TErrorReporter.done;
begin

end;

constructor TErrorReporter.init;
begin

end;

{ TLogFileErrorReporter }

procedure TLogFileErrorReporter.close;
begin
	CloseHandle(FHandle);
	FHandle := INVALID_HANDLE_VALUE;
end;

function TLogFileErrorReporter.open: Boolean;
begin
	FHandle := CreateFile(PChar(ParamStr(0)+'.heapchecker.log'), GENERIC_WRITE,0,nil,CREATE_ALWAYS,0,0);
	Result := FHandle <> INVALID_HANDLE_VALUE ;
end;

procedure TLogFileErrorReporter.output(s: string);
var
	w: Cardinal;
begin
	s := s + sLineBreak;
	WriteFile(FHandle, PChar(s)^, Length(s), w, nil);
end;

initialization
	Initialize;

finalization
	Finalize;
end.
