unit ImageLoad;

interface

uses Windows, SysUtils, Graphics, jpeg, GifImage;

function LoadImageFromFile(const PathName: WideString): TGraphic;

implementation

uses wsStream, wsFileOp;

function CreateStream(const FileName: widestring): TFileStreamW;
begin
  try
    Result:=TFileStreamW.Create(FileName, fmOpenRead or fmShareDenyWrite);
  except
    try
       Result:=TFileStreamW.Create(FileName, fmOpenRead or fmShareDenyNone);
    except
       Result:=nil;
    end;
  end;
end;

function LoadImageFromFile(const PathName: WideString): TGraphic;
var
  fs: TFileStreamW;
  ext: WideString;
begin
  Result := nil;
  fs := CreateStream(PathName);
  try
    ext := CharLowerW(PWChar(ExtractFileExtW(PathName)));
    if ext = '.bmp' then begin
      Result := TBitmap.Create;
    end else if (ext = '.jpg') or (ext = '.jpeg') then begin
      Result := TJPEGImage.Create;
    end else if ext = '.gif' then begin
      Result := TGIFImage.Create;
    end else exit;
    try
      Result.LoadFromStream(fs);
    except
      Result.Free;
      Result := nil;
    end;
  finally
    fs.Free;
  end;
end;

end.
