unit PSpeedButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Buttons,Graphics;

type
  TPSpeedButton = class(TSpeedButton)
  private
    fColor:TColor;
    procedure SetColor(c:TColor);
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure Paint;override;
  public
    { Public 錾 }
  published
    property Color:TColor read fColor write SetColor;
    { Published 錾 }
  end;

procedure Register;

implementation

uses Types;

procedure Register;
begin
  RegisterComponents('Samples', [TPSpeedButton]);
end;

{ TPSpeedButton }

procedure TPSpeedButton.Paint;
var
 r:trect;
begin
  inherited;
  r.Top := ClientRect.Top+4;
  r.Left := ClientRect.Left+4;
  r.Right := ClientRect.Right-5;
  r.Bottom := ClientRect.Bottom-5;
  if fColor <> clNone then begin
    Canvas.Brush.Color:=fColor;
    Canvas.FillRect(r);
  end else begin
    Canvas.Pen.Color := clRed;
    Canvas.Brush.Color := clWhite;
    Canvas.FillRect(r);
    Canvas.FrameRect(r);
    Canvas.MoveTo(r.Right, r.Top);
    Canvas.LineTo(r.Left, r.Bottom);
  end;
end;

procedure TPSpeedButton.SetColor(c: TColor);
begin
  fColor := c;
  Invalidate;
end;

end.
