unit WshModal;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, TntForms, psvActiveScript;

type

  TWSHEngine=class(TpsvActiveScriptWindow)
  private
    FMObj,FEObj,FAObj:IDispatch;
  protected
    procedure OnErrorEvent(Sender: TObject; Line, Pos: Integer; ASrc,
      ADescription: WideString);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    function ExecString(const Value:widestring;mode:integer):boolean;
    function ExecFile(const PathName:widestring):boolean;
  end;

implementation


uses WSHObjects, wsfileop, TextFileEncoding;

const
 Lang_JScript =0;
 Lang_VBScript=1;
 Lang_Python=2;
 Lang_RubyScript=3;
 Lang_PerlScript=4;

{ TWSHEngine }

constructor TWSHEngine.Create(AOwner: TComponent);
begin
  inherited;
  FMObj:=TMObj.Create;
  FEObj:=TEObj.Create;
  FAObj:=TAObj.Create;

    self.AddNamedItem('Mana',FMObj);
    self.AddNamedItem('Editor',FAObj);
    self.AddNamedItem('SubEditor',FEObj);
  OnError:=OnErrorEvent;
end;

destructor TWSHEngine.Destroy;
begin
  FMObj:=nil;
  FEObj:=nil;
  FAObj:=nil;

  inherited;
end;

function TWSHEngine.ExecFile(const PathName: widestring): boolean;
var
  s: widestring;
  mode: integer;
  fc: TFileCode;
  AError: boolean;
begin
  s := WideUpperCase(ExtractFileExtW(PathName));
  if s = '.JS' then mode:=Lang_JScript else
    if s = '.VBS' then mode:=Lang_VBScript else
      if s = '.PYS' then mode:=Lang_Python else
        if s = '.RB' then mode:=Lang_RubyScript else
          if s = '.PLS' then mode:=Lang_PerlScript
            else mode:=-1;
  Result := ExecString(LoadFromFile(PathName, fc, true, AError), mode);
  if AError then Result := false;
end;

function TWSHEngine.ExecString(const Value: widestring;mode:integer): boolean;
begin
  Result:=true;
  try
    case mode of
      Lang_JScript    :Self.ScriptLanguage:='JScript';
      Lang_VBScript   :Self.ScriptLanguage:='VBScript';
      Lang_Python     :Self.ScriptLanguage:='python';
      Lang_RubyScript :Self.ScriptLanguage:='RubyScript';
      Lang_PerlScript :Self.ScriptLanguage:='PerlScript';
      else Self.ScriptLanguage:='';
    end;
    self.Execute(Value);
  except
    Result:=false;
  end;
end;


procedure TWSHEngine.OnErrorEvent(Sender: TObject; Line, Pos: Integer;
  ASrc, ADescription: WideString);
var
  s1 : WideString;
begin
  s1 := IntToStr(Line + 1) + #13#10 + ADescription;
  if Length(ASrc) > 0 then s1 := s1 + #13#10 + '''' + ASrc + '''';
  MessageBoxW(Application.Handle, PWChar(s1),
    PWChar(TntApplication.Title), MB_OK or MB_ICONSTOP or MB_TASKMODAL);
end;

end.
