unit WSHResultUnit;

interface

uses Windows, Messages, SysUtils, Classes, Forms, ActiveX,
psvActiveScript;

type
  TWSHResult = class(TpsvActiveScriptWindow)
  protected
  public
    constructor Create(AOwner: TComponent); override;
    function DoFunc(code: WideString): Widestring;
  end;


implementation

{ TWSHJScript }

constructor TWSHResult.Create(AOwner: TComponent);
begin
  inherited;
end;

{ TAObj }

type
  TAObj = class(TInterfacedObject, IDispatch)
  protected
    function GetTypeInfoCount(out Count: Integer): HResult; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;
  public
    ResultText: WideString;
  end;

const
  DISPID_RESULTTEXT  = 1;
const
  DISPATCH_PROPERTYGET_OR_METHOD = DISPATCH_METHOD or DISPATCH_PROPERTYGET;

function TAObj.GetIDsOfNames(const IID: TGUID; Names: Pointer; NameCount,
  LocaleID: Integer; DispIDs: Pointer): HResult;
type
  TDispIDsArray = array[0..0] of TDISPID;
  PDispIDsArray = ^TDispIDsArray;
var
  IDs: PDispIDsArray absolute DispIDs;
  i: integer;
  Name: WideString;
begin
  if NameCount > 1 then Result := DISP_E_UNKNOWNNAME
  else
    if NameCount < 1 then Result := E_INVALIDARG
    else Result := S_OK;
  for i := 0 to NameCount - 1 do
    IDs[i] := DISPID_UNKNOWN;
  if NameCount = 1 then
    begin
      Name := PWideChar(Names^);
      Name:=UpperCase(Name);
      if Name = 'RESULTTEXT' then IDs[0] := DISPID_RESULTTEXT else
       Result := DISP_E_UNKNOWNNAME;
    end;
end;

function TAObj.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Pointer(TypeInfo) := nil;
  Result := E_NOTIMPL;
end;

function TAObj.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Count := 0;
  Result := S_OK;
end;

function TAObj.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  PVariantArray = ^TVariantArray;
  TVariantArray = array[0..65535] of Variant;
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = array[0..65535] of Integer;
var
  Parms: PDispParams;
begin
  Result := S_OK;
  Parms := @Params;
  case DispID of
    DISPID_RESULTTEXT:
    begin
      case Flags of
        DISPATCH_PROPERTYGET,DISPATCH_PROPERTYGET_OR_METHOD:
        begin
          if Parms.cArgs=0 then begin
            if (VarResult<>nil) then
              POleVariant(VarResult)^ := ResultText;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        DISPATCH_PROPERTYPUT:
        begin
          if Parms.cArgs=1 then begin
            ResultText:=PVariantArray(Parms.rgvarg)^[0];
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        else begin
          Result := DISP_E_MEMBERNOTFOUND;
        end;
      end;
    end;
    else Result := DISP_E_MEMBERNOTFOUND;
  end;//case

end;

function TWSHResult.DoFunc(code: WideString): Widestring;
var
  AAObj: TAObj;
begin
  AAObj := TAObj.Create;
  self.AddNamedItem('AObj', AAObj);
  ScriptLanguage:='JScript';
  Execute(code);
  Result := AAObj.ResultText;
end;

end.
